import { ArrayType } from '../../types/rga-array/ArrayType';
import { BinaryType } from '../../types/rga-binary/BinaryType';
import { CrdtDecoder } from '../../../json-crdt-patch/util/binary/CrdtDecoder';
import { ITimestamp } from '../../../json-crdt-patch/clock';
import { Model } from '../../model';
import { ObjectType } from '../../types/lww-object/ObjectType';
import { StringType } from '../../types/rga-string/StringType';
import type { JsonNode } from '../../types';
export declare abstract class AbstractDecoder extends CrdtDecoder {
    protected doc: Model;
    protected abstract ts(): ITimestamp;
    protected decodeRoot(doc: Model): void;
    decodeNode(): JsonNode;
    private createConst;
    decodeObj(length: number): ObjectType;
    private decodeObjChunk;
    decodeArr(length: number): ArrayType;
    private decodeArrChunk;
    decodeStr(length: number): StringType;
    private decodeStrChunk;
    decodeBin(length: number): BinaryType;
    private decodeBinChunk;
    private decodeVal;
}
