"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogicalDecoder = void 0;
var tslib_1 = require("tslib");
var ClockDecoder_1 = require("../../../json-crdt-patch/codec/clock/ClockDecoder");
var model_1 = require("../../model");
var AbstractDecoder_1 = require("./AbstractDecoder");
var LogicalDecoder = (function (_super) {
    (0, tslib_1.__extends)(LogicalDecoder, _super);
    function LogicalDecoder() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LogicalDecoder.prototype.decode = function (data) {
        this.reset(data);
        var _a = (0, tslib_1.__read)(this.b1vuint56(), 2), clockTableLength = _a[1];
        this.decodeClockTable(clockTableLength);
        var doc = (this.doc = model_1.Model.withLogicalClock(this.clockDecoder.clock));
        this.decodeRoot(doc);
        return doc;
    };
    LogicalDecoder.prototype.decodeClockTable = function (length) {
        var _a = (0, tslib_1.__read)(this.uint53vuint39(), 2), sessionId = _a[0], time = _a[1];
        this.clockDecoder = new ClockDecoder_1.ClockDecoder(sessionId, 0);
        this.clockDecoder.pushTuple(sessionId, time);
        for (var i = 1; i < length; i++) {
            var ts = this.uint53vuint39();
            this.clockDecoder.pushTuple(ts[0], ts[1]);
        }
    };
    LogicalDecoder.prototype.ts = function () {
        var _a = (0, tslib_1.__read)(this.id(), 2), sessionIndex = _a[0], timeDiff = _a[1];
        var id = this.clockDecoder.decodeId(sessionIndex, timeDiff);
        return id;
    };
    return LogicalDecoder;
}(AbstractDecoder_1.AbstractDecoder));
exports.LogicalDecoder = LogicalDecoder;
